/*
  Toggler, the updated text-folding or element show/hide toggle implementation 
  for PmWiki.  A fork of the Untoggle Recipe

  Original JavaScript by BonRouge : bonrouge.com/br.php?page=togglit
  Adapted for PmWiki in 2009 by Petko Yotov http://5ko.fr
  Modified to add a "sticky" feature so the toggler is always visible while content
  is expande.  Also add use of images as "clickers" or Togglers.
  Modifications June, 2022 by
  - Kirk Siqveland, Edmonds, WA
  www.snippetspub.com 
  
  The following text is into the Public domain.
*/


/** STICKY Toggle Image: **/
  function stickyToggler() {
    var StickyToggler = document.getElementsByClassName("stickytog") ;

    for (var tick = StickyToggler.length - 1; tick >= 0; tick--) {       
      var stickytop = StickyToggler[tick].nextSibling.offsetTop ;      
      if (window.pageYOffset > stickytop) {
        StickyToggler[tick].classList.add("stucktog") ;
      } else{
        StickyToggler[tick].classList.remove("stucktog") ;
      }
    }  
  }
  window.addEventListener('DOMMouseScroll', stickyToggler, {passive: false}) ;
  window.addEventListener('mousewheel',     stickyToggler, {passive: false}) ;
  window.addEventListener('scroll',         stickyToggler, {passive: false}) ;
  // window.addEventListener('wheel', stickyToggler, {passive: false} ) ;



function toggleNext(Elmnt) {
  var nxt = Elmnt.nextSibling ;
  while(nxt.nodeType != 1)
    nxt = nxt.nextSibling;
    if(nxt.style.display== "none"  ) {
       nxt.style.display = "block" ;
       Elmnt.classList.add("stickytog") ;
    }else{
      nxt.style.display = "none" ;
      Elmnt.classList.remove("stickytog") ;
      Elmnt.classList.remove("stucktog") ;
      // On re-fold, return toggle element to top of screen
      if(Elmnt.getBoundingClientRect().top < 1){ 
         Elmnt.scrollIntoView(true) ; 
      }
    }
}

function setToggleElements(bytag,byclass){
  var tags      = document.getElementsByTagName(bytag) ;
  var findClass = new RegExp("(^|\\s)"+byclass+"(\\s|$)") ; 

  for (tick=0; tick<tags.length; tick++) {
    if (findClass.test(tags[tick].className)) {
      tags[tick].className+=" clicker" ;
      tags[tick].onclick=function(){ toggleNext(this) } ;
      toggleNext(tags[tick]) ;
    }
  }
}

setToggleElements("div" ,'toggler') ;
setToggleElements("dt"  ,'toggler') ;
setToggleElements("img" ,'toggler') ;



